"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
class ConsoleLogger extends index_1.Logger {
    constructor() {
        super(...arguments);
        this._count = 0;
    }
    normalizeParams() {
        super.normalizeParams();
        if (this._levels.indexOf("CONSOLE") < 0) {
            this._levels.unshift("CONSOLE");
            this._level++;
        }
    }
    _log(level, ...args) {
        this._count++;
        if (level === "CONSOLE") {
            console.log(...args);
            return;
        }
        console.log("[" + level + "]", ...args);
    }
    getCount() {
        return this._count;
    }
    static getModda() {
        return {
            uuid: "Webda/ConsoleLogger",
            label: "ConsoleLogger",
            description: "Output all everything to the console",
            webcomponents: [],
            logo: "images/icons/none.png",
            configuration: {
                schema: {
                    type: "object",
                    properties: {
                        logLevel: {
                            type: "string",
                            value: "INFO"
                        },
                        logLevels: {
                            type: "string",
                            value: "ERROR,WARN,CONSOLE,INFO,DEBUG"
                        }
                    }
                }
            }
        };
    }
}
exports.ConsoleLogger = ConsoleLogger;
//# sourceMappingURL=consolelogger.js.map