"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_typescript_1 = require("mocha-typescript");
const assert = require("assert");
const test_1 = require("../test");
const __1 = require("..");
const Task = require("../../test/models/task");
let CoreModelTest = class CoreModelTest extends test_1.WebdaTest {
    unsecureLoad() {
        let object = new __1.CoreModel();
        object.load({
            _test: "plop",
            test: "plop"
        });
        assert.equal(object._test, undefined);
        assert.equal(object.test, "plop");
    }
    secureConstructor() {
        let object = new __1.CoreModel();
        object.load({
            _test: "plop",
            test: "plop",
            __serverOnly: "server"
        }, true);
        assert.equal(object._test, "plop");
        assert.equal(object.test, "plop");
        return object;
    }
    jsonExport() {
        let object = this.secureConstructor();
        let exported = JSON.parse(JSON.stringify(object));
        assert.equal(exported.__serverOnly, undefined);
        assert.equal(exported._test, "plop");
        assert.equal(exported.test, "plop");
        assert.equal(exported._gotContext, undefined);
    }
    jsonStoredExport() {
        let object = this.secureConstructor();
        let exported = object.toStoredJSON();
        assert.equal(exported.__serverOnly, "server");
        assert.equal(exported._test, "plop");
        assert.equal(exported.test, "plop");
    }
    jsonStoredExportStringify() {
        let object = this.secureConstructor();
        let exported = JSON.parse(object.toStoredJSON(true));
        assert.equal(exported.__serverOnly, "server");
        assert.equal(exported._test, "plop");
        assert.equal(exported.test, "plop");
        assert.equal(exported._gotContext, undefined);
    }
    withContext() {
        return __awaiter(this, void 0, void 0, function* () {
            let ctx = yield this.newContext();
            let task = new Task();
            ctx.write(task);
            let result = JSON.parse(ctx.getResponseBody());
            assert.equal(result._gotContext, true);
        });
    }
};
__decorate([
    mocha_typescript_1.test("Verify unsecure loaded")
], CoreModelTest.prototype, "unsecureLoad", null);
__decorate([
    mocha_typescript_1.test("Verify secure constructor")
], CoreModelTest.prototype, "secureConstructor", null);
__decorate([
    mocha_typescript_1.test("Verify JSON export")
], CoreModelTest.prototype, "jsonExport", null);
__decorate([
    mocha_typescript_1.test("Verify JSON stored export")
], CoreModelTest.prototype, "jsonStoredExport", null);
__decorate([
    mocha_typescript_1.test("Verify JSON stored export - stringify")
], CoreModelTest.prototype, "jsonStoredExportStringify", null);
__decorate([
    mocha_typescript_1.test("Verify Context access within output to server")
], CoreModelTest.prototype, "withContext", null);
CoreModelTest = __decorate([
    mocha_typescript_1.suite
], CoreModelTest);
//# sourceMappingURL=coremodel.spec.js.map