"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const coremodel_1 = require("./coremodel");
/**
 * First basic model for Ident
 * @class
 */
class User extends coremodel_1.CoreModel {
    constructor() {
        super(...arguments);
        this._lastPasswordRecovery = 0;
        this._roles = [];
        this._groups = [];
        this._idents = [];
    }
    //getIdents(): CoreModelDefinition
    getGroups() {
        return this._groups;
    }
    getRoles() {
        return this._roles;
    }
    addRole(role) {
        if (this.hasRole(role)) {
            return;
        }
        this._roles.push(role);
    }
    hasRole(role) {
        return this._roles.indexOf(role) >= 0;
    }
    removeRole(role) {
        let ind = this._roles.indexOf(role);
        if (ind < 0) {
            return;
        }
        this._roles.splice(ind, 1);
    }
    addGroup(group) {
        if (this.inGroup(group)) {
            return;
        }
        this._groups.push(group);
    }
    inGroup(group) {
        if (group === "all") {
            return true;
        }
        return this._groups.indexOf(group) >= 0;
    }
    removeGroup(group) {
        let ind = this._groups.indexOf(group);
        if (ind < 0) {
            return;
        }
        this._groups.splice(ind, 1);
    }
    lastPasswordRecoveryBefore(timestamp) {
        return this._lastPasswordRecovery < timestamp;
    }
    getPassword() {
        return this.__password;
    }
    setPassword(password) {
        this.__password = password;
    }
}
exports.User = User;
//# sourceMappingURL=user.js.map