"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const AclPolicyMixIn = Sup => class extends Sup {
    constructor() {
        super(...arguments);
        this.__acls = new Map();
    }
    getAcls() {
        return this.__acls;
    }
    setAcls(acls) {
        this.__acls = acls;
    }
    _httpGetAcls(ctx) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.__acls;
        });
    }
    _httpPutAcls(ctx) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__acls = ctx.body;
            yield this.save();
        });
    }
    // Should cache the user role in the session
    getGroups(ctx, user) {
        let groups = user.getGroups();
        if (!groups) {
            groups = [];
        }
        groups = groups.slice(0);
        groups.push(user.uuid);
        return groups;
    }
    hasPermission(ctx, user, action) {
        return __awaiter(this, void 0, void 0, function* () {
            let groups = this.getGroups(ctx, user);
            for (let i in this.__acls) {
                if (groups.indexOf(i) >= 0) {
                    if (this.__acls[i] === "all" ||
                        this.__acls[i].split(",").indexOf(action) >= 0) {
                        return true;
                    }
                }
            }
            return false;
        });
    }
    canAct(ctx, action) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.__acls || !ctx.getCurrentUserId()) {
                throw 403;
            }
            let user = yield ctx.getCurrentUser();
            if (yield this.hasPermission(ctx, user, action)) {
                return this;
            }
            throw 403;
        });
    }
};
exports.AclPolicyMixIn = AclPolicyMixIn;
//# sourceMappingURL=aclpolicy.js.map