"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_typescript_1 = require("mocha-typescript");
const assert = require("assert");
const index_1 = require("../index");
var config = require("../../test/config.json");
const Utils = require("../../test/utils");
class AclPolicyModel extends index_1.AclPolicyMixIn(index_1.CoreModel) {
}
let AclPolicyTest = class AclPolicyTest {
    before() {
        return __awaiter(this, void 0, void 0, function* () {
            this._webda = new index_1.Core(config);
            this._ctx = yield this._webda.newContext(new index_1.HttpContext("test.webda.io", "GET", "/"));
            this._session = this._ctx.getSession();
            this._session.login("user-uid", "none");
            this.model = new AclPolicyModel();
            this._user = new index_1.User();
            this._user.uuid = "user-uid";
            this._user.addGroup("gip-123");
            this._ctx.getCurrentUser = () => __awaiter(this, void 0, void 0, function* () {
                return this._user;
            });
        });
    }
    get() {
        return __awaiter(this, void 0, void 0, function* () {
            yield Utils.throws(this.model.canAct.bind(this.model, this._ctx, "get"));
            this.model.__acls["gip-123"] = "get";
            assert.equal(yield this.model.canAct(this._ctx, "get"), this.model);
        });
    }
    multipermissions() {
        return __awaiter(this, void 0, void 0, function* () {
            yield Utils.throws(this.model.canAct.bind(this.model, this._ctx, "action"));
            this.model.__acls["gip-123"] = "get,action";
            assert.equal(yield this.model.canAct(this._ctx, "get"), this.model);
            assert.equal(yield this.model.canAct(this._ctx, "action"), this.model);
        });
    }
    multigroups() {
        return __awaiter(this, void 0, void 0, function* () {
            yield Utils.throws(this.model.canAct.bind(this.model, this._ctx, "action"));
            this.model.__acls["gip-124"] = "get,action";
            this.model.__acls["gip-123"] = "get";
            this.model.__acls["gip-122"] = "get,action";
            assert.equal(yield this.model.canAct(this._ctx, "get"), this.model);
            yield Utils.throws(this.model.canAct.bind(this.model, this._ctx, "action"));
        });
    }
    userid() {
        return __awaiter(this, void 0, void 0, function* () {
            yield Utils.throws(this.model.canAct.bind(this.model, this._ctx, "action"));
            this.model.__acls["user-uid"] = "get";
            this.model.__acls["gip-122"] = "get,action";
            assert.equal(yield this.model.canAct(this._ctx, "get"), this.model);
            yield Utils.throws(this.model.canAct.bind(this.model, this._ctx, "action"));
        });
    }
    all() {
        return __awaiter(this, void 0, void 0, function* () {
            yield Utils.throws(this.model.canAct.bind(this.model, this._ctx, "action"));
            this.model.__acls["gip-124"] = "get,action";
            this.model.__acls["user-uid"] = "all";
            this.model.__acls["gip-122"] = "get,action";
            assert.equal(yield this.model.canAct(this._ctx, "get"), this.model);
            assert.equal(yield this.model.canAct(this._ctx, "action"), this.model);
            assert.equal(yield this.model.canAct(this._ctx, "delete"), this.model);
            assert.equal(yield this.model.canAct(this._ctx, "whatever"), this.model);
        });
    }
};
__decorate([
    mocha_typescript_1.test
], AclPolicyTest.prototype, "get", null);
__decorate([
    mocha_typescript_1.test
], AclPolicyTest.prototype, "multipermissions", null);
__decorate([
    mocha_typescript_1.test
], AclPolicyTest.prototype, "multigroups", null);
__decorate([
    mocha_typescript_1.test
], AclPolicyTest.prototype, "userid", null);
__decorate([
    mocha_typescript_1.test
], AclPolicyTest.prototype, "all", null);
AclPolicyTest = __decorate([
    mocha_typescript_1.suite
], AclPolicyTest);
//# sourceMappingURL=aclpolicy.spec.js.map