"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mixin = (Sup, rolesMap, permissive = false) => class extends Sup {
    getRoles(ctx) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!ctx.getCurrentUserId()) {
                throw 403;
            }
            // If roles are cached in session
            if (ctx.getSession().roles) {
                return ctx.getSession().roles;
            }
            let user = yield ctx.getCurrentUser();
            // Cache roles in session
            ctx.getSession().roles = user.getRoles();
            return ctx.getSession().roles;
        });
    }
    canAct(ctx, action) {
        return __awaiter(this, void 0, void 0, function* () {
            // If this action doesn't require role
            if (!rolesMap[action]) {
                if (permissive) {
                    return this;
                }
                throw 403;
            }
            let roles = yield this.getRoles(ctx);
            if (roles.indexOf(rolesMap[action]) >= 0) {
                return this;
            }
            throw 403;
        });
    }
};
exports.RolePolicyMixIn = mixin;
//# sourceMappingURL=rolepolicy.js.map