"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_typescript_1 = require("mocha-typescript");
const assert = require("assert");
const index_1 = require("../index");
var config = require("../../test/config.json");
const Utils = require("../../test/utils");
class RolePolicyModel extends index_1.RolePolicyMixIn(index_1.CoreModel, {
    get: "member",
    update: "member",
    delete: "admin"
}) {
}
class RolePolicyModelPermissive extends index_1.RolePolicyMixIn(index_1.CoreModel, {
    get: "member",
    create: "member"
}, true) {
}
let RolePolicyTest = class RolePolicyTest {
    before() {
        return __awaiter(this, void 0, void 0, function* () {
            this._webda = new index_1.Core(config);
            this._ctx = yield this._webda.newContext(new index_1.HttpContext("test.webda.io", "GET", "/"));
            this._session = this._ctx.newSession();
            this._session.login("none", "none");
            this._ctx.getCurrentUser = () => __awaiter(this, void 0, void 0, function* () {
                return this._user;
            });
            this.nonPermissive = new RolePolicyModel();
            this.permissive = new RolePolicyModelPermissive();
            this._user = new index_1.User();
            this._user.addRole("member");
        });
    }
    get() {
        return __awaiter(this, void 0, void 0, function* () {
            assert.equal(yield this.permissive.canAct(this._ctx, "get"), this.permissive);
            assert.equal(yield this.nonPermissive.canAct(this._ctx, "get"), this.nonPermissive);
        });
    }
    action() {
        return __awaiter(this, void 0, void 0, function* () {
            assert.equal(yield this.permissive.canAct(this._ctx, "action"), this.permissive);
            yield Utils.throws(this.nonPermissive.canAct.bind(this.nonPermissive, this._ctx, "action"));
        });
    }
    delete() {
        return __awaiter(this, void 0, void 0, function* () {
            assert.equal(yield this.permissive.canAct(this._ctx, "delete"), this.permissive);
            yield Utils.throws(this.nonPermissive.canAct.bind(this.nonPermissive, this._ctx, "delete"));
            this._user.addRole("admin");
            this._session.roles = undefined;
            assert.equal(yield this.nonPermissive.canAct(this._ctx, "delete"), this.nonPermissive);
        });
    }
};
__decorate([
    mocha_typescript_1.test
], RolePolicyTest.prototype, "get", null);
__decorate([
    mocha_typescript_1.test
], RolePolicyTest.prototype, "action", null);
__decorate([
    mocha_typescript_1.test
], RolePolicyTest.prototype, "delete", null);
RolePolicyTest = __decorate([
    mocha_typescript_1.suite
], RolePolicyTest);
//# sourceMappingURL=rolepolicy.spec.js.map