"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const test_1 = require("../test");
const assert = require("assert");
class QueueTest extends test_1.WebdaTest {
    simple(queue, inconsistentSize = false) {
        return __awaiter(this, void 0, void 0, function* () {
            var msg;
            yield queue.sendMessage({
                type: 1
            });
            let size = yield queue.size();
            if (!inconsistentSize) {
                assert.equal(size, 1);
            }
            yield queue.sendMessage({
                type: 2
            });
            // Pause for 1s - to verify the repopulation
            yield this.sleep(1000);
            size = yield queue.size();
            if (!inconsistentSize) {
                assert.equal(size, 2);
            }
            msg = yield queue.receiveMessage();
            size = yield queue.size();
            if (!inconsistentSize) {
                assert.equal(size, 2);
            }
            if (msg.length > 0) {
                yield queue.deleteMessage(msg[0].ReceiptHandle);
            }
            // Pause for 1s - to verify the repopulation
            yield this.sleep(1000);
            msg = yield queue.receiveMessage();
            if (!inconsistentSize) {
                assert.equal(msg.length, 1);
            }
            if (msg.length > 0) {
                yield queue.deleteMessage(msg[0].ReceiptHandle);
            }
        });
    }
}
exports.QueueTest = QueueTest;
//# sourceMappingURL=queue.spec.js.map