"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
class Queue extends index_1.Service {
    sendMessage(params) {
        return __awaiter(this, void 0, void 0, function* () {
            throw Error("Virtual abstract class - concrete only for MixIn usage");
        });
    }
    receiveMessage() {
        return __awaiter(this, void 0, void 0, function* () {
            throw Error("Virtual abstract class - concrete only for MixIn usage");
        });
    }
    deleteMessage(id) {
        return __awaiter(this, void 0, void 0, function* () {
            throw Error("Virtual abstract class - concrete only for MixIn usage");
        });
    }
    size() {
        return __awaiter(this, void 0, void 0, function* () {
            throw Error("Virtual abstract class - concrete only for MixIn usage");
        });
    }
    _workerResume() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this._timeout) {
                clearTimeout(this._timeout);
            }
            this._timeout = setTimeout(this._workerReceiveMessage.bind(this), 1000);
        });
    }
    _workerReceiveMessage() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this._interrupt) {
                return;
            }
            try {
                let items = yield this.receiveMessage();
                try {
                    if (items.length === 0) {
                        return this._workerResume();
                    }
                    for (var i = 0; i < items.length; i++) {
                        let msg = items[i];
                        let event = JSON.parse(msg.Body);
                        yield this.callback(event);
                        yield this.deleteMessage(msg.ReceiptHandle);
                    }
                    return this._workerResume();
                }
                catch (err) {
                    this._webda.log("ERROR", "Notification", err);
                    return this._workerResume();
                }
            }
            catch (err) {
                this.pause *= 2;
                this._webda.log("ERROR", err);
                setTimeout(this._workerReceiveMessage.bind(this), this.pause * 1000);
            }
        });
    }
    worker(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            this.pause = 1;
            this.callback = callback;
            while (!this._interrupt) {
                yield this._workerReceiveMessage();
            }
        });
    }
    stop() {
        this._interrupt = true;
        if (this._timeout) {
            clearTimeout(this._timeout);
        }
    }
}
exports.Queue = Queue;
//# sourceMappingURL=queueservice.js.map