"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
/**
 * Execute a custom JS file, it is almost like a custom Service except that this will not be a singleton
 * And it will be instantiate every call
 *
 * Configuration
 * '/url': {
 *    'type': 'file',
 *    'file': './customroute.js'
 * }
 *
 */
class FileRouteHelper extends index_1.Executor {
    /**
     * @ignore
     */
    execute(ctx) {
        if (typeof ctx._route.file === "string") {
            var include = ctx._route.file;
            if (include.startsWith("./")) {
                include = process.cwd() + "/" + include;
            }
            let fct = require(include);
            if (fct.default) {
                fct = fct.default;
            }
            return fct(ctx);
        }
    }
}
exports.FileRouteHelper = FileRouteHelper;
//# sourceMappingURL=file.js.map