import { Service } from "../index";
interface ConfigurationProvider {
    getConfiguration(id: string): Promise<Map<string, any>>;
}
/**
 * Handle sessionSecret ( rolling between two secrets ) expire every hour
 * Handle longTermSecret ( rolling between two longer secret ) expire every month
 */
export default class ConfigurationService extends Service {
    protected _configuration: any;
    protected _nextCheck: number;
    protected _sourceService: any;
    protected _sourceId: string;
    private _interval;
    init(): Promise<void>;
    stop(): void;
    reinit(config: any): Promise<void>;
    _loadConfiguration(): Promise<Map<string, any>>;
    _checkUpdate(): Promise<void>;
    _updateNextCheck(): void;
}
export { ConfigurationProvider, ConfigurationService };
