import { Service, Context } from "../index";
/**
 * An Executor is a Service that is designed to handle HTTP request to it
 * It has output methods to be able to communicate with the client
 *
 * An executor has several properties set :
 *  body : The request
 *  session : The current session object
 *  _params : like all services (but the parameters from the route definition are added)
 *  _route : The current route used
 *  query : With the query parameters
 *
 * @class
 */
declare class Executor extends Service {
    /**
     * Add a route dynamicaly
     *
     * @param {String} url of the route can contains dynamic part like {uuid}
     * @param {Array[]} methods
     * @param {Function} executer Method to execute for this route
     */
    _addRoute(url: string, methods: string[], executer: Function, swagger?: object, allowPath?: boolean): void;
    /**
     * Main method called by the webda framework if the route don't specify a _method
     */
    execute(ctx: Context): Promise<any>;
    /**
     * Use this method to enhance the context if needed
     *
     */
    updateContext(ctx: Context): void;
    /**
     * Init the routes
     */
    initRoutes(): void;
    /**
     *
     */
    resolve(): void;
}
export { Executor };
