import { Binary, Context } from "../index";
/**
 * FileBinary handles the storage of binary on a hard drive
 *
 * The structure used for now is
 * /folder/{hash}/data
 * /folder/{hash}/{targetStore}_{uuid}
 * /folder/{hash}/challenge
 *
 * It takes one parameter
 *  folder: "path"
 *
 * See Binary the general interface
 */
declare class FileBinary extends Binary {
    /** @ignore */
    constructor(webda: any, name: any, params: any);
    _initRoutes(): boolean;
    _get(info: any): ReadableStream<any>;
    _getPath(hash: any, postfix?: any): any;
    _touch(path: any): void;
    getPutUrl(ctx: Context): string;
    /**
     * Will give you the redirect url
     *
     * @ignore
     */
    putRedirectUrl(ctx: Context): Promise<string>;
    /**
     * Store the binary sent
     *
     * Check the hashs match and that a storage folder exists
     * The storage folder should have been created by the putRedirectUrl
     *
     * @ignore
     */
    storeBinary(ctx: Context): Promise<void>;
    getUsageCount(hash: any): Promise<number>;
    _cleanHash(hash: any): void;
    _cleanUsage(hash: any, uuid: any): void;
    delete(targetStore: any, object: any, property: any, index: any): any;
    challenge(hash: any, challenge: any): boolean;
    cascadeDelete(info: any, uuid: any): void;
    _store(file: any, targetStore: any, object: any): void;
    store(targetStore: any, object: any, property: any, file: any, metadatas: any, index?: string): Promise<any>;
    update(targetStore: any, object: any, property: any, index: any, file: any, metadatas: any): Promise<any>;
    ___cleanData(): Promise<void>;
    static getModda(): {
        uuid: string;
        label: string;
        description: string;
        webcomponents: any[];
        documentation: string;
        logo: string;
        configuration: {
            default: {
                folder: string;
            };
            schema: {
                type: string;
                properties: {
                    expose: {
                        type: string;
                    };
                    folder: {
                        type: string;
                    };
                };
                required: string[];
            };
        };
    };
}
export { FileBinary };
