import { Service } from "../index";
interface IEmailTemplate {
    renderAll(file: string, options: any): any;
}
interface TemplatesMap {
    [key: string]: IEmailTemplate;
}
/**
 * A basic Mailer based on the nodemailer module
 *
 * Inside config it is the nodemailer module option for the method createTransport ( https://nodemailer.com/ )
 *
 * Only ses transport module is installed by default
 *
 * Parameters
 * config: { ... }
 */
declare class Mailer extends Service {
    _transporter: any;
    _templates: TemplatesMap;
    /** @ignore */
    constructor(webda: any, name: any, params: any);
    init(): Promise<void>;
    _getTemplate(name: any): IEmailTemplate;
    /**
     *
     * @params options Options to pass to the sendMail option of the nodemailer module
     * @params callback to pass to the sendMail
     */
    send(options: any, callback?: any): Promise<any>;
    /** @ignore */
    static getModda(): {
        uuid: string;
        label: string;
        description: string;
        webcomponents: any[];
        logo: string;
        configuration: {
            default: {
                config: {};
            };
            schema: {
                type: string;
                properties: {
                    config: {
                        type: string;
                    };
                };
                required: string[];
            };
        };
    };
}
export { Mailer, TemplatesMap, IEmailTemplate };
