import { Store, CoreModel } from "../index";
/**
 * Simple file storage of object
 *
 * Storage structure
 *   /folder/{uuid}
 *
 *
 * Parameters:
 *  folder: to store to
 *
 */
declare class FileStore<T extends CoreModel> extends Store<T> {
    /** @ignore */
    constructor(webda: any, name: any, options: any);
    file(uid: any): string;
    exists(uid: any): Promise<boolean>;
    _find(request: any, offset: any, limit: any): Promise<any>;
    _save(object: any, uid: any): Promise<any>;
    _upsertItemToCollection(uid: any, prop: any, item: any, index: any, itemWriteCondition: any, itemWriteConditionField: any, updateDate: Date): Promise<void>;
    _removeAttribute(uuid: string, attribute: string): Promise<void>;
    _deleteItemFromCollection(uid: any, prop: any, index: any, itemWriteCondition: any, itemWriteConditionField: any, updateDate: Date): Promise<any>;
    _delete(uid: any, writeCondition: any): Promise<void>;
    _patch(object: any, uid: any, writeCondition: any): Promise<any>;
    _update(object: any, uid: any, writeCondition?: any): Promise<any>;
    getAll(uids: any): Promise<any>;
    _get(uid: string): Promise<any>;
    _incrementAttribute(uid: any, prop: any, value: any, updateDate: Date): Promise<any>;
    __clean(): Promise<void>;
    static getModda(): {
        uuid: string;
        label: string;
        description: string;
        webcomponents: any[];
        documentation: string;
        logo: string;
        configuration: {
            default: {
                folder: string;
            };
            widget: {
                tag: string;
                url: string;
            };
            schema: {
                type: string;
                properties: {
                    folder: {
                        type: string;
                    };
                };
                required: string[];
            };
        };
    };
}
export { FileStore };
