import { Store, CoreModel } from "../index";
interface StorageMap {
    [key: string]: any;
}
declare class MemoryStore<T extends CoreModel> extends Store<T> {
    storage: StorageMap;
    init(): Promise<void>;
    exists(uid: any): Promise<boolean>;
    _find(request: any, offset: any, limit: any): Promise<any>;
    _save(object: any, uid: any): Promise<T>;
    _delete(uid: any): Promise<void>;
    _patch(object: any, uid: any): Promise<T>;
    _update(object: any, uid: any): Promise<T>;
    getAll(uids: any): Promise<any>;
    _getSync(uid: any): T;
    _removeAttribute(uuid: string, attribute: string): Promise<void>;
    _get(uid: any): Promise<T>;
    __clean(): Promise<void>;
    _incrementAttribute(uid: any, prop: any, value: any, updateDate: Date): Promise<T>;
    _upsertItemToCollection(uid: any, prop: any, item: any, index: any, itemWriteCondition: any, itemWriteConditionField: any, updateDate: Date): Promise<void>;
    _deleteItemFromCollection(uid: any, prop: any, index: any, itemWriteCondition: any, itemWriteConditionField: any, updateDate: Date): Promise<T>;
    static getModda(): {
        uuid: string;
        label: string;
        description: string;
        webcomponents: any[];
        documentation: string;
        logo: string;
        configuration: {
            default: {};
            widget: {
                tag: string;
                url: string;
            };
            schema: {
                type: string;
                properties: {};
            };
        };
    };
}
export { MemoryStore, StorageMap };
