"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const store_spec_1 = require("./store.spec");
const assert = require("assert");
const mocha_typescript_1 = require("mocha-typescript");
let MemoryStoreTest = class MemoryStoreTest extends store_spec_1.StoreTest {
    getIdentStore() {
        return this.getService("MemoryIdents");
    }
    getUserStore() {
        return this.getService("MemoryUsers");
    }
    deleteAsyncHttp() {
        return __awaiter(this, void 0, void 0, function* () {
            let executor, ctx;
            ctx = yield this.webda.newContext(undefined);
            let identStore = this.getIdentStore();
            yield identStore.save({
                uuid: "toDelete",
                test: "ok"
            });
            yield identStore.delete("toDelete");
            executor = this.getExecutor(ctx, "test.webda.io", "GET", "/memory/idents/toDelete");
            assert.notEqual(executor, undefined);
            yield this.assertThrowsAsync(executor.execute.bind(executor, ctx), err => err == 404);
            executor = this.getExecutor(ctx, "test.webda.io", "PUT", "/memory/idents/toDelete");
            assert.notEqual(executor, undefined);
            yield this.assertThrowsAsync(executor.execute.bind(executor, ctx), err => err == 404);
            executor = this.getExecutor(ctx, "test.webda.io", "DELETE", "/memory/idents/toDelete");
            assert.notEqual(executor, undefined);
            yield this.assertThrowsAsync(executor.execute.bind(executor, ctx), err => err == 404);
        });
    }
};
__decorate([
    mocha_typescript_1.test
], MemoryStoreTest.prototype, "deleteAsyncHttp", null);
MemoryStoreTest = __decorate([
    mocha_typescript_1.suite
], MemoryStoreTest);
exports.MemoryStoreTest = MemoryStoreTest;
//# sourceMappingURL=memory.spec.js.map