const assert = require("assert");

async function assertThrowsAsync(fn, regExp) {
  let f = () => {};
  try {
    await fn();
  } catch (e) {
    f = () => {
      throw e
    };
  } finally {
    assert.throws(f, regExp);
  }
}

async function sleep(time) {
  return new Promise((resolve, reject) => {
    setTimeout(resolve, time);
  });
}

module.exports = {
  throws: assertThrowsAsync,
  sleep: sleep
}
